// Injection Wizard
// --An application for injecting traffic in WEP protected Wi-Fi networks--
// Version: 1.0
// Copyright (C) 2010 Fernando Pablo Romero Navarro <fernpromero@gmail.com>
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package cliente;

import java.util.*;
import java.lang.reflect.*;


public class ClientConf {
    
    private HashMap<String, AttrSetter> proparamsetter=null;
    private HashMap<String, AttrSetter> propservsetter=null;
    private int stage=0;
    private String ip=null;
    private int port=0;
    private String iface=null;
    private boolean fcs=false;
    private int header_type=0;
    private String subnet=null;
    private int search_type=0;
    private int minret=Limits.MINRETS;
    private int mintime=Limits.MINTIME;
    private String language=null;

    
    public ClientConf(){
        proparamsetter=new HashMap<String, AttrSetter>(9);
        propservsetter=new HashMap<String, AttrSetter>(8);
        Class cls=this.getClass();
        Class[] params=new Class[1];
        Method setter=null;
        Str2Int str2int=new Str2Int();
        Ans2Bool ans2bool=new Ans2Bool();
        Head2Int head2int=new Head2Int();
        Srch2Int sch2int= new Srch2Int();
        
        try{            
            params[0]=String.class;
            setter=cls.getMethod("setIP", params);
            proparamsetter.put(PropertyManager.IPA,
                           new AttrSetter(this, setter, null));
            
            params[0]=int.class;
            setter=cls.getMethod("setPort", params);
            proparamsetter.put(PropertyManager.PRT,
                           new AttrSetter(this, setter, str2int));

            params[0]=String.class;
            setter=cls.getMethod("setIface", params);
            proparamsetter.put(PropertyManager.IFC,
                           new AttrSetter(this, setter, null));

            propservsetter.put(Msg.WIFACE,
                           new AttrSetter(this, setter, null));

            params[0]=boolean.class;
            setter=cls.getMethod("setFCS", params);
            proparamsetter.put(PropertyManager.FCS,
                           new AttrSetter(this, setter, ans2bool));

            propservsetter.put(Msg.FCS,
                           new AttrSetter(this, setter, null));
                        
            params[0]=int.class;
            setter=cls.getMethod("setHeaderType", params);
            proparamsetter.put(PropertyManager.HDR,
                           new AttrSetter(this, setter, head2int));

            propservsetter.put(Msg.MONHDR,
                           new AttrSetter(this, setter, new IncrInt()));

            params[0]=String.class;
            setter=cls.getMethod("setSubnet", params);
            proparamsetter.put(PropertyManager.SUB,
                           new AttrSetter(this, setter, null));

            propservsetter.put(Msg.SUBNET,
                           new AttrSetter(this, setter, null));
            
            params[0]=int.class;
            setter=cls.getMethod("setSearchType", params);
            proparamsetter.put(PropertyManager.SCH,
                           new AttrSetter(this, setter, sch2int));

            propservsetter.put(Msg.SEARCH,
                           new AttrSetter(this, setter, null));

            params[0]=int.class;
            setter=cls.getMethod("setMinRetries", params);
            proparamsetter.put(PropertyManager.RET,
                           new AttrSetter(this, setter, str2int));

            propservsetter.put(Msg.MINRET,
                           new AttrSetter(this, setter, null));

            params[0]=int.class;
            setter=cls.getMethod("setMinTime", params);
            proparamsetter.put(PropertyManager.TMO,
                           new AttrSetter(this, setter, str2int));

            propservsetter.put(Msg.MINTMO,
                           new AttrSetter(this, setter, null));

            params[0]=int.class;
            setter=cls.getMethod("setStage", params);
            propservsetter.put(Msg.STAGE,
                           new AttrSetter(this, setter, null));

            params[0]=String.class;
            setter=cls.getMethod("setLanguage", params);
            proparamsetter.put(PropertyManager.LNG,
                           new AttrSetter(this, setter, null));

        }catch(Exception e){
            System.err.println("Error inicializando config. cliente");
            e.printStackTrace(System.err);
        }
    }

    public int getStage(){
        return stage;
    }

    public void setStage(int st){
        stage=st;
    }

    public String getIP(){
        return ip;
    }

    public void setIP(String ipaddr){
        ip=ipaddr;
    }

    public int getPort(){
        return port;
    }

    public void setPort(int srvport){
            port=srvport;
    }

    public String getIface(){
        return iface;
    }

    public void setIface(String ifname){
        iface=ifname;
    }

    public boolean hasFCS(){
        return fcs;
    }

    public void setFCS(boolean hasfcs){
       fcs=hasfcs;
    }

    public int getHeaderType(){
        return header_type;
    }

    public void setHeaderType(int hdrtype){
        header_type=hdrtype;
    }

    public String getSubnet(){
        return subnet;
    }

    public void setSubnet(String subnetarget){
        subnet=subnetarget;
    }

    public int getSearchType(){
        return search_type;
    }

    public void setSearchType(int srchtype){
        search_type=srchtype;
    }

    public int getMinRetries(){
        return minret;
    }

    public void setMinRetries(int minretries){
        minret=minretries;
    }

    public int getMinTime(){
        return mintime;
    }

    public void setMinTime(int mintimeout){
        mintime=mintimeout;
    }

    public String getLanguage() {
        return language;
    }

    public void setLanguage(String lang){
        language=lang;
    }

    public void load(Properties props){
        Iterator it=null;
        AttrSetter atrset=null;
        String key=null;
        String val=null;

        
        if(props!=null){
           it=props.keySet().iterator();

            while(it.hasNext()){
                key=(String)it.next();
                val=props.getProperty(key);
                if(PropertyManager.CLICNFKEYS.contains(key) && val!=null){
                    atrset=proparamsetter.get(key);
                    atrset.setValue(val);
                }
            }
        }
    }

    public boolean save(){
        Properties props=new Properties();        

        if(ip!=null)
            props.put(PropertyManager.IPA, ip);

        if(port!=0)
            props.put(PropertyManager.PRT, Integer.toString(port));

        if(iface!=null)
            props.put(PropertyManager.IFC, iface);
        
        if(fcs)
            props.put(PropertyManager.FCS, "y");
        else
            props.put(PropertyManager.FCS, "n");

        if(header_type>=0 && header_type < PropertyManager.HDRVALUES.size())
            props.put(PropertyManager.HDR,
                      PropertyManager.HDRVALUES.get(header_type).toLowerCase());

        if(subnet!=null)
            props.put(PropertyManager.SUB, subnet);

        if(search_type>=0 && search_type < PropertyManager.SCHVALUES.size())
            props.put(PropertyManager.SCH,
                      PropertyManager.SCHVALUES.get(search_type).toLowerCase());

        if(minret>=Limits.MINRETS && minret<=Limits.MAXRETS)
            props.put(PropertyManager.RET, Integer.toString(minret));

        if(mintime>=Limits.MINTIME && mintime<=Limits.MAXTIME)
            props.put(PropertyManager.TMO, Integer.toString(mintime));

        if(language!=null)
            props.put(PropertyManager.LNG, language.toLowerCase());

        return PropertyManager.saveProperties(props);
    }

    public void update(HashMap<String, Object> cfgopts){
        Iterator<String> it=cfgopts.keySet().iterator();
        String key=null;
        AttrSetter attrsetter=null;
        Object value=null;

        while(it.hasNext()){
            key=it.next();
            value=cfgopts.get(key);
            if(value!=null && propservsetter.containsKey(key)){
                attrsetter=propservsetter.get(key);
                attrsetter.setValue(value);
            }
        }
    }

    
    @Override
    public String toString(){
        StringBuffer sb=new StringBuffer(128);
        sb.append("\nstage"); sb.append("="); sb.append(stage);
        sb.append("\nip"); sb.append("="); sb.append(ip);
        sb.append("\nport"); sb.append("="); sb.append(port);
        sb.append("\niface"); sb.append("="); sb.append(iface);
        sb.append("\nfcs"); sb.append("="); sb.append(fcs);
        sb.append("\nheader_type"); sb.append("="); sb.append(header_type);
        sb.append("\nsubnet"); sb.append("="); sb.append(subnet);
        sb.append("\nsearch_type"); sb.append("="); sb.append(search_type);
        sb.append("\nminret"); sb.append("="); sb.append(minret);
        sb.append("\nmintime"); sb.append("="); sb.append(mintime);
        return sb.toString();
    }
}


class AttrSetter{
    
    private Method setmethod=null;
    private ArgumentFactory argfact=null;
    private Object instance=null;

    public AttrSetter(Object instance, Method setter, ArgumentFactory fact){
        this.instance=instance;
        this.setmethod=setter;
        this.argfact=fact;
    }

    public void setValue(Object paramvalue){
        if(paramvalue!=null){
            try{
                Object attrvalue=null;
                Object[] args=new Object[1];

                if(argfact!=null)                    
                    attrvalue=argfact.createArg(paramvalue);
                else
                    attrvalue=paramvalue;

                args[0]=attrvalue;
                setmethod.invoke(instance, args);

            }catch(Exception e){
                System.err.println("Error de actualización de config.");
                e.printStackTrace(System.err);
            }
        }
    }
}



interface ArgumentFactory{
    Object createArg(Object param);
}


class Str2Int implements ArgumentFactory{

    public Object createArg(Object param){
        String strparam=(String)param;
        Integer value=null;
        int tmp=0;
        
        try{
            tmp=Integer.parseInt(strparam);
            value=new Integer(tmp);
        }catch(NumberFormatException nfe){
            value=new Integer(Integer.MAX_VALUE);
            nfe.printStackTrace(System.err);
        }
        return value;
    }
}

class Ans2Bool implements ArgumentFactory{

    private final static String ANS_YES="y";
    private final static String ANS_NO="n";

    public Object createArg(Object param){
        Boolean value=null;

        if(param.equals(ANS_YES))
            value=Boolean.TRUE;
        else if(param.equals(ANS_NO))
            value=Boolean.TRUE;

        return value;
    }
}

class Head2Int implements ArgumentFactory{

    public Object createArg(Object param){
        int value=Integer.MAX_VALUE;

        String hdrtype=((String)param).toUpperCase();

        if(PropertyManager.HDRVALUES.contains(hdrtype))
            value=PropertyManager.HDRVALUES.indexOf(hdrtype);

        return new Integer(value);
    }
}


class Srch2Int implements ArgumentFactory{

    public Object createArg(Object param){
        int value=Integer.MAX_VALUE;
        String searchtype=((String)param).toUpperCase();

        if(PropertyManager.SCHVALUES.contains(searchtype))
            value=PropertyManager.SCHVALUES.indexOf(searchtype);

        return new Integer(value);
    }
}

class IncrInt implements ArgumentFactory{

    public Object createArg(Object param){
        Integer pint=(Integer)param;
        return new Integer(pint.intValue()+1);
    }
}